unit Keyboardleds;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,WinInet,
  StdCtrls, ExtCtrls, ComCtrls;

type
  TForm1 = class(TForm)
    Timer1: TTimer;
    CheckBox1: TCheckBox;
    Timer2: TTimer;
    CheckBox2: TCheckBox;
    TrackBar1: TTrackBar;
    TrackBar2: TTrackBar;

    procedure Timer1Timer(Sender: TObject);
    procedure CheckBox1Click(Sender: TObject);
    procedure CheckBox2Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Timer2Timer(Sender: TObject);
    procedure TrackBar1Change(Sender: TObject);

  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
 leucht:boolean;
 rider:word;
  Form1: TForm1;

implementation

{$R *.DFM}



type
  TKeyType = (ktCapsLock, ktNumLock, ktScrollLock);

procedure SetLedState(KeyCode: TKeyType; bOn: Boolean);
var
  KBState: TKeyboardState;
  Code: Byte;
begin
  case KeyCode of
    ktScrollLock: Code := VK_SCROLL;
    ktCapsLock: Code := VK_CAPITAL;
    ktNumLock: Code := VK_NUMLOCK;
  end;
  GetKeyboardState(KBState);
  if (Win32Platform = VER_PLATFORM_WIN32_NT) then
  begin
    if Boolean(KBState[Code]) <> bOn then
    begin
      keybd_event(Code,
                  MapVirtualKey(Code, 0),
                  KEYEVENTF_EXTENDEDKEY,
                  0);

      keybd_event(Code,
                  MapVirtualKey(Code, 0),
                  KEYEVENTF_EXTENDEDKEY or KEYEVENTF_KEYUP,
                  0);
    end;
  end
  else
  begin
    KBState[Code] := Ord(bOn);
    SetKeyboardState(KBState);
  end;
end;

procedure TForm1.CheckBox1Click(Sender: TObject);
begin
If Checkbox1.checked then begin Timer1.enabled:=true; checkbox2.checked:=false; end else Timer1.enabled:=false;
end;




procedure TForm1.Timer1Timer(Sender: TObject);
begin
If leucht=false then begin SetLedState(ktCapsLock, True);  // CapsLock on
  SetLedState(ktNumLock, True);  // NumLock on
  SetLedState(ktScrollLock, True);  // ScrollLock on
  leucht:=true; end else begin
  SetLedState(ktCapsLock, false);  // CapsLock on
  SetLedState(ktNumLock, false);  // NumLock on
  SetLedState(ktScrollLock, false);  // ScrollLock on
  leucht:=false;

  end;
end;
procedure TForm1.CheckBox2Click(Sender: TObject);
begin
If Checkbox2.checked then begin Timer2.enabled:=true; checkbox1.checked:=false; end else Timer2.enabled:=false;

end;

procedure TForm1.FormCreate(Sender: TObject);
begin
rider:=1;
leucht:=FALSE;
end;

procedure TForm1.Timer2Timer(Sender: TObject);
begin
 SetLedState(ktCapsLock, false);  // CapsLock on
SetLedState(ktNumLock, false);  // NumLock on
SetLedState(ktScrollLock, false);  // ScrollLock on
case rider of
1:SetLedState(ktCapsLock, true);  // CapsLock on
2:SetLedState(ktNumLock, true);  // NumLock on
3:begin SetLedState(ktScrollLock, true); rider:=0; end; // ScrollLock on
end;
inc (rider);
end;

procedure TForm1.TrackBar1Change(Sender: TObject);
begin
Timer1.Interval:=50*(21-Trackbar1.Position);
Timer2.Interval:=50*(21-Trackbar2.position);
end;

end.
